//
//  Adapter.h
//  Shogiban2
//
//  Created by KOYAMA Yoshiaki on Sun Aug 10 2003.
//  Copyright (c) 2003 KOYAMA Yoshiaki. All rights reserved.
//

#import <Cocoa/Cocoa.h>

#define MAX_WIDTH	16
#define MAX_HEIGHT	11

@class BoardCell;

@interface Adapter : NSObject {
    IBOutlet id _boardManager;
    IBOutlet id _ykifController;
         
    int _komaKind;
    int _x;
    int _y;
    int _count;
    NSImage *_komaImage;
    NSImage *_boardBackImage;
    NSImage *_boardSelectBackImage;
    BOOL _rotateFlag;
    NSString *_senteString;
    NSString *_goteString;
}

- (void)drawBackBoard;
- (void)drawKoma: (BoardCell *)cell;
- (void)drawKomaCell;
- (BOOL)rotateFlag;
- (void)rotate;
- (void)rotateCell;
- (void)drawBoardSelectBacckImage:(BoardCell *)cell;
- (void)drawSenteGote:(int)komaKind;
- (void)drawSenteGoteString:(NSString *)str :(NSPoint)pos;

- (void)moveBoardDrag:(int)x :(int)y;
- (void)enterBoardDrag:(int)x :(int)y;
- (void)exitBoardDrag;
- (int)getKomaKind:(int)x :(int)y;
- (NSImage *)getKomaImage:(int)x :(int)y;
- (NSImage *)getKomaImage;
- (NSImage *)getKomaImageKind: (int)komaKind;
- (int)startKomaKind;

@end
