//
//  Adapter.m
//  Shogiban2
//
//  Created by KOYAMA Yoshiaki on Sun Aug 10 2003.
//  Copyright (c) 2003 KOYAMA Yoshiaki. All rights reserved.
//

#import "Adapter.h"
#import "BoardCellKoma.h"
#import "BoardCell.h"
#import "BoardManager.h"
#import "YKifController.h"

@implementation Adapter

// 
- (id)init {
    NSBundle *bundle;
    NSString *path;

    self = [super init];

    bundle = [NSBundle mainBundle];
    path = [bundle pathForResource:@"koma" ofType:@"tiff"];
    _komaImage = [[NSImage alloc] initByReferencingFile: path];

    path = [bundle pathForResource:@"board" ofType:@"tiff"];
    _boardBackImage = [[NSImage alloc] initByReferencingFile: path];

    path = [bundle pathForResource:@"selectBoard" ofType:@"tiff"];
    _boardSelectBackImage = [[NSImage alloc] initByReferencingFile: path];
 
    _senteString = NSLocalizedString(@"SENTESTR",@"S");
    _goteString = NSLocalizedString(@"GOTESTR",@"G");

    _rotateFlag = NO;
    return self;
}

// Ղ̕`
- (void)drawBackBoard {
    NSPoint pos;
    NSRect rect;

    pos = NSMakePoint(0, 0);
    rect = NSMakeRect(0,0,KOMA_WIDTH*MAX_WIDTH,KOMA_HEIGHT*MAX_HEIGHT);        

    [_boardBackImage compositeToPoint:pos fromRect:rect 				 	operation:NSCompositeSourceOver];
}

// ̕`
- (void)drawKoma: (BoardCell *)cell {

    _komaKind = [cell boardCellKomaKind];
    _x = [cell boardCellX];
    _y = [cell boardCellY];
    _count = [cell boardCellCount];

    if (_rotateFlag == YES) {
        [self rotateCell];
    }

    [self drawKomaCell];
}

// ۂ̋̕`
- (void)drawKomaCell {
    NSPoint pos;
    NSRect rect;
    NSMutableDictionary *dicAttr = [[NSMutableDictionary alloc] init];
    NSFont *fontAttr = [NSFont fontWithName: @"Helvetica" size:9];
    NSString *str;

    pos = NSMakePoint(_x*KOMA_WIDTH, _y*KOMA_HEIGHT);

    if ((_komaKind >= 1) && (_komaKind <= 8)) {
        rect = NSMakeRect((_komaKind - 1)*KOMA_WIDTH,KOMA_HEIGHT*3
                ,KOMA_WIDTH,KOMA_HEIGHT);
    } else if ((_komaKind >= 9) && (_komaKind <= 10)) {
        rect = NSMakeRect((_komaKind-9+1)*KOMA_WIDTH,KOMA_HEIGHT*2
                ,KOMA_WIDTH,KOMA_HEIGHT);
    } else if ((_komaKind >= 11) && (_komaKind <= 14)) {
        rect = NSMakeRect((_komaKind - 11 + 4)*KOMA_WIDTH,KOMA_HEIGHT*2
                ,KOMA_WIDTH,KOMA_HEIGHT);
    } else if ((_komaKind >= -8) && (_komaKind <= -1)) {
        rect = NSMakeRect((-_komaKind - 1)*KOMA_WIDTH,KOMA_HEIGHT*1
                ,KOMA_WIDTH,KOMA_HEIGHT);
    } else if ((_komaKind >= -10) && (_komaKind <= -9)) {
        rect = NSMakeRect((-_komaKind-9+1)*KOMA_WIDTH,KOMA_HEIGHT*0
                ,KOMA_WIDTH,KOMA_HEIGHT);
    } else if ((_komaKind >= -14) && (_komaKind <= -11)) {
        rect = NSMakeRect((-_komaKind - 11 + 4)*KOMA_WIDTH,KOMA_HEIGHT*0
                ,KOMA_WIDTH,KOMA_HEIGHT);
    }

    if ((_komaKind != KOMA_NASHI) && (_komaKind != KOMA_WAKU)) {
        [_komaImage compositeToPoint: pos fromRect: rect 				 	operation:NSCompositeSourceOver];
    }

    if ((_x > 10) && (_komaKind != KOMA_WAKU) && (_count > 1)) {
        str = [NSString stringWithFormat:@"%d",_count];
        [dicAttr setObject: [NSColor blackColor] forKey: 					NSForegroundColorAttributeName];
        [dicAttr setObject: fontAttr forKey: NSFontAttributeName];

        pos.x += KOMA_WIDTH;
        [str drawAtPoint: pos withAttributes: dicAttr];
    }
    
    [dicAttr release];
}

- (BOOL)rotateFlag {
    return _rotateFlag;
}

// ]
- (void)rotate {
    if (_rotateFlag == YES) {
        _rotateFlag = NO;
    } else {
        _rotateFlag = YES;
    }
}

// 180x]
- (void)rotateCell {

    if ((0 <= _x) && (_x <= 10)) {
        _x = 10 - _x;
    }
    _y = 10 - _y;

    if ((_komaKind != KOMA_NASHI) && (_komaKind != KOMA_WAKU)) {        
        _komaKind = -1 * _komaKind;
    }
}

// Iwi̕\
- (void)drawBoardSelectBacckImage:(BoardCell *)cell {
    NSPoint pos;
    NSRect rect;

    _komaKind = [cell boardCellKomaKind];
    _x = [cell boardCellX];
    _y = [cell boardCellY];
    _count = [cell boardCellCount];

    if (_rotateFlag == YES) {
        [self rotateCell];
    }

    if (_count != 0) {
        pos = NSMakePoint(_x*KOMA_WIDTH, _y*KOMA_HEIGHT);
        rect = NSMakeRect(_x*KOMA_WIDTH, _y*KOMA_WIDTH, KOMA_WIDTH, KOMA_HEIGHT);        
        [_boardSelectBackImage compositeToPoint:pos fromRect:rect 				 	operation:NSCompositeSourceOver];
    }
}

// ̕\
- (void)drawSenteGote:(int)komaKind {

    if (_rotateFlag == YES) {
        if (komaKind > 0) {
            [self drawSenteGoteString:_senteString :NSMakePoint(KOMA_WIDTH*11, KOMA_HEIGHT*10)];
            [self drawSenteGoteString:_goteString :NSMakePoint(KOMA_WIDTH*11, KOMA_HEIGHT*5)];
        } else {
            [self drawSenteGoteString:_senteString :NSMakePoint(KOMA_WIDTH*11, KOMA_HEIGHT*5)];
            [self drawSenteGoteString:_goteString :NSMakePoint(KOMA_WIDTH*11, KOMA_HEIGHT*10)];
        }
    } else {
        if (komaKind > 0) {
            [self drawSenteGoteString:_senteString :NSMakePoint(KOMA_WIDTH*11, KOMA_HEIGHT*5)];
            [self drawSenteGoteString:_goteString :NSMakePoint(KOMA_WIDTH*11, KOMA_HEIGHT*10)];
        } else {
            [self drawSenteGoteString:_senteString :NSMakePoint(KOMA_WIDTH*11, KOMA_HEIGHT*10)];
            [self drawSenteGoteString:_goteString :NSMakePoint(KOMA_WIDTH*11, KOMA_HEIGHT*5)];
        }
    }
}

// ۂɐ̕\
- (void)drawSenteGoteString:(NSString *)str :(NSPoint)pos {
    NSMutableDictionary *dicAttr = [[NSMutableDictionary alloc] init];
    NSFont *fontAttr = [NSFont fontWithName: @"HiraKakuPro-W3" size:10];
    
    [dicAttr setObject: [NSColor blackColor] forKey: 	NSForegroundColorAttributeName];
    [dicAttr setObject: fontAttr forKey: NSFontAttributeName];

    [str drawAtPoint:pos withAttributes: dicAttr];
    [dicAttr release];
}

// performDragOperationB
- (void)moveBoardDrag:(int)x :(int)y {

    _x = x;
    _y = y;
    _komaKind = KOMA_NASHI;
    _count = 0;

    if (_rotateFlag == YES) {
        [self rotateCell];
    }

    [_boardManager moveBoardDrag:_x :_y];
}

// draggingEnteredB
- (void)enterBoardDrag:(int)x :(int)y {
    _x = x;
    _y = y;
    _komaKind = KOMA_NASHI;
    _count = 0;

    if (_rotateFlag == YES) {
        [self rotateCell];
    }

    [_boardManager enterBoardDrag:_x :_y];
}

// draggingExited
- (void)exitBoardDrag {
    [_boardManager exitBoardDrag];
}

// ̎ނԂ
- (int)getKomaKind:(int)x :(int)y {

    _x = x;
    _y = y;
    _komaKind = KOMA_NASHI;
    _count = 0;

    if (_rotateFlag == YES) {
        [self rotateCell];
    }

    _komaKind = [_boardManager getKomaKind:_x :_y];

    if (_rotateFlag == YES) {
        [self rotateCell];
    }
    
    return _komaKind;
}

// ̉摜Ԃ
- (NSImage *)getKomaImageKind: (int)komaKind {

    _komaKind = komaKind;

    if (_rotateFlag == YES) {
        [self rotateCell];
    }

    return [self getKomaImage];
}

// ̉摜Ԃ
- (NSImage *)getKomaImage:(int)x :(int)y {
    
    _x = x;
    _y = y;
    _komaKind = KOMA_NASHI;
    _count = 0;

    if (_rotateFlag == YES) {
        [self rotateCell];
    }

    _komaKind = [_boardManager getKomaKind:_x :_y];

    if (_rotateFlag == YES) {
        [self rotateCell];
    }

    return [self getKomaImage];
}

// ۂɋ̉摜Ԃ
- (NSImage *)getKomaImage {
    NSPoint pos;
    NSRect rect;
    NSImage *image;
    NSSize aSize;

    pos = NSMakePoint(0, 0);

    if ((_komaKind >= 1) && (_komaKind <= 8)) {
        rect = NSMakeRect((_komaKind - 1)*KOMA_WIDTH,KOMA_HEIGHT*3
                ,KOMA_WIDTH,KOMA_HEIGHT);
    } else if ((_komaKind >= 9) && (_komaKind <= 10)) {
        rect = NSMakeRect((_komaKind-9+1)*KOMA_WIDTH,KOMA_HEIGHT*2
                ,KOMA_WIDTH,KOMA_HEIGHT);            
    } else if ((_komaKind >= 11) && (_komaKind <= 14)) {
        rect = NSMakeRect((_komaKind-11+4)*KOMA_WIDTH,KOMA_HEIGHT*2
                ,KOMA_WIDTH,KOMA_HEIGHT);
    } else if ((_komaKind >= -8) && (_komaKind <= -1)) {
        rect = NSMakeRect((-_komaKind - 1)*KOMA_WIDTH,KOMA_HEIGHT*1
                ,KOMA_WIDTH,KOMA_HEIGHT);
    } else if ((_komaKind >= -10) && (_komaKind <= -9)) {
        rect = NSMakeRect((-_komaKind-9+1)*KOMA_WIDTH,KOMA_HEIGHT*0
                ,KOMA_WIDTH,KOMA_HEIGHT);
    } else if ((_komaKind >= -14) && (_komaKind <= -11)) {
        rect = NSMakeRect((-_komaKind-11+4)*KOMA_WIDTH,KOMA_HEIGHT*0
                ,KOMA_WIDTH,KOMA_HEIGHT);
    }

    if ((_komaKind == KOMA_WAKU) || (_komaKind == KOMA_NASHI)) {
        return nil;
    } else {

        aSize = NSMakeSize(KOMA_WIDTH,KOMA_HEIGHT);
        image = [[NSImage alloc] initWithSize:aSize];

        [image lockFocus];
        [_komaImage compositeToPoint: pos fromRect: rect 				operation:NSCompositeSourceOver];
        [image unlockFocus];

        return image;
    }
}

// ŏ̋Ԃ
- (int)startKomaKind {

    _komaKind = [_ykifController startKomaKind];

   if (_rotateFlag == YES) {
        [self rotateCell];
    }

    return _komaKind;
}

// ̉B
- (void)dealloc {
    [_komaImage release];
    [_boardBackImage release];
    [_boardSelectBackImage release];

    [super dealloc];
}

@end
