//
//  BoardManager.h
//  Shogiban2
//
//  Created by KOYAMA Yoshiaki on Sun Aug 10 2003.
//  Copyright (c) 2003 KOYAMA Yoshiaki. All rights reserved.
//

#import <Cocoa/Cocoa.h>

#define MAX_WIDTH	16
#define MAX_HEIGHT	11

@class BoardCell;

@interface BoardManager : NSObject {
    IBOutlet id _adapter;
    IBOutlet id _ykifController;
    IBOutlet id _promoteWindow;
    IBOutlet id _promoteImageView;
    IBOutlet id _boardView;
    IBOutlet id _boardWindow;
        
    BoardCell *_board[MAX_WIDTH][MAX_HEIGHT];
    BoardCell *_boardDrag;
    BoardCell *_boardStock;
    BoardCell *_boardPlace;
    BoardCell *_boardSource;
    BoardCell *_boardDestination;
    BoardCell *_boardSheetDrag;
}

- (IBAction)endPromoteYes:(id)sender;
- (IBAction)endPromoteNo:(id)sender;

- (void)drawBoard;
- (void)initBoardManager:(int)teaiwari;

- (void)frontStepKif:(BoardCell *)selectSource :(BoardCell *)selectDestination
    :(BoardCell *)placeSource :(BoardCell *)placeDestination;
- (void)backStepKif:(BoardCell *)selectSrc :(BoardCell *)selectDest
    :(BoardCell *)placeSrc :(BoardCell *)placeDest 
    :(BoardCell *)selectSrc1 :(BoardCell *)selectDest1
    :(BoardCell *)placeSrc1 :(BoardCell *)placeDest1;

- (int)getKomaKind:(int)x :(int)y;

-(void)moveBoardDrag:(int)x :(int)y;
- (void)enterBoardDrag:(int)x :(int)y;
- (void)exitBoardDrag;
- (void)moveBackBoardDrag;
- (BOOL)canPut:(int)x :(int)y;
- (BOOL)canMove:(int)x :(int)y;

- (void)sheetDidEnd:(NSWindow *)sheet 
            returnCode:(int)returnCode
            contextInfo:(void *)contextInfo;

- (void)makeKif;

@end
