//
//  XKifController.m
//  Shogiban2
//
//  Created by KOYAMA Yoshiaki on Sun Aug 10 2003.
//  Copyright (c) 2003 KOYAMA Yoshiaki. All rights reserved.
//

#import "XKifController.h"
#import "YKifController.h"
#import "BoardCell.h"
#import "BoardCellKoma.h"

@implementation XKifController

int xhirate[MAX_HEIGHT][MAX_WIDTH] = {
    {-99,-99,-99,-99,-99,-99,-99,-99,-99,-99,-99,-99,-99,-99,-99,-99},

    {-99,SENTE_KYOUSYA,SENTE_KEIMA,SENTE_GIN,SENTE_KIN,SENTE_OU,
    SENTE_KIN,SENTE_GIN,SENTE_KEIMA,SENTE_KYOUSYA,-99,0,-99,-99,-99,-99},

    {-99,0,SENTE_KAKU,0,0,0,0,0,SENTE_HISYA,0,-99,0,-99,0,-99,-99},
   
    {-99,SENTE_FU,SENTE_FU,SENTE_FU,SENTE_FU,SENTE_FU,SENTE_FU,
    SENTE_FU,SENTE_FU,SENTE_FU,-99,0,-99,0,-99,-99},

    {-99,0,0,0,0,0,0,0,0,0,-99,0,-99,0,-99,-99},

    {-99,0,0,0,0,0,0,0,0,0,-99,-99,-99,-99,-99,-99},

    {-99,0,0,0,0,0,0,0,0,0,-99,0,-99,0,-99,-99},

    {-99,GOTE_FU,GOTE_FU,GOTE_FU,GOTE_FU,GOTE_FU,GOTE_FU,
    GOTE_FU,GOTE_FU,GOTE_FU,-99,0,-99,0,-99,-99},

    {-99,0,GOTE_HISYA,0,0,0,0,0,GOTE_KAKU,0,-99,0,-99,0,-99,-99},
   
    {-99,GOTE_KYOUSYA,GOTE_KEIMA,GOTE_GIN,GOTE_KIN,GOTE_OU,
    GOTE_KIN,GOTE_GIN,GOTE_KEIMA,GOTE_KYOUSYA,-99,0,-99,-99,-99,-99},

    {-99,-99,-99,-99,-99,-99,-99,-99,-99,-99,-99,-99,-99,-99,-99,-99}
};

// B
- (void)initBoardController:(int)teaiwari {
    int i, j;
    
    for (i=0; i<MAX_WIDTH; i++) {
        for (j=0; j<MAX_HEIGHT; j++) {
            [_board[i][j] release];
            switch (teaiwari) {
                case TEAI_HIRATE:
                    _board[i][j] = [[BoardCell alloc] initBoardCell:i :j 
                                    :xhirate[j][i] : NO];
                    break;
            }
        }
    }

    [_selectSource release];
    _selectSource = [[BoardCell alloc] initBoardCell:0 :0 :KOMA_NASHI : NO];

    [_selectDestination release];
    _selectDestination = [[BoardCell alloc] initBoardCell:0 :0 :KOMA_NASHI : NO];

    [_placeSource release];
    _placeSource = [[BoardCell alloc] initBoardCell:0 :0 :KOMA_NASHI : NO];

    [_placeDestination release];
    _placeDestination = [[BoardCell alloc] initBoardCell:0 :0 :KOMA_NASHI : NO];
    _senteKomaKind = KOMA_NASHI;
    _indexKif = 0;

}

// path t@CoANSString ɕϊB
- (void)contentOfData:(NSData *)data {
    _content = [[NSString alloc] initWithData:data encoding: NSASCIIStringEncoding];
}

// ΐ푊AtȂǂ̏oB
- (void)setName {
    NSScanner *scan;
    NSCharacterSet *set;
    NSString *bStr, *fStr, *dStr;
    int count = 0;
    BOOL dFlag = NO;
    BOOL flag = NO;

    bStr = nil;
    fStr = nil;
	dStr = nil;
    scan = [NSScanner scannerWithString:_content];
    set = [NSCharacterSet characterSetWithCharactersInString:@" \n\r"];
        
    do {
        bStr = fStr;
        flag = [scan scanUpToCharactersFromSet:set intoString:&fStr];

        if (dFlag == YES) {
            dStr = [dStr stringByAppendingString:fStr];
            dStr = [dStr stringByAppendingString:@" "];
            count++;
            if (count == 4) {
                dFlag = NO;
                _date = dStr;
                [_date retain];
            }
        }


        if ([fStr isEqualToString:@"--"] == YES) {
            flag = [scan scanUpToCharactersFromSet:set intoString:&fStr];
            dStr = fStr;
            dStr = [dStr stringByAppendingString:@" "];
            dFlag = YES;
        }


        if ([fStr isEqualToString:@"vs."] == YES) {
            flag = [scan scanUpToCharactersFromSet:set intoString:&fStr];
            _senteName = [self dividingName:fStr];
            [_senteName retain];
            _goteName = [self dividingName:bStr];
            [_goteName retain];
            flag = NO;
        }
    } while (flag == YES);
}

// @܂ł̕ԂB
- (NSString *)dividingName:(NSString *)str {
    NSRange range;
    NSString *name;
    unsigned int location;

    range.location = 0;
    range.length = 0;
    range = [str rangeOfString:@"@"];
    if (range.length == 0) {
        name = str;
    } else {
        location = range.location;
        range.location = 0;
        range.length = location;
        name = [str substringWithRange:range];
    }
    return name;
}


- (NSString *)senteName {
    return _senteName;
}

- (NSString *)goteName {
    return _goteName;
}

- (NSString *)date {
    return _date;
}

// xshogiۑeLXgt@CB
- (void)loadKif {
    NSScanner *scan;
    NSCharacterSet *set;
    NSString *str;
    BOOL flag = NO;
    BOOL fStart = NO;
    unsigned int len = 0;
    NSString *dot;

    scan = [NSScanner scannerWithString:_content];
    set = [NSCharacterSet characterSetWithCharactersInString:@" \n\r"];

    do {
        flag = [scan scanUpToCharactersFromSet:set intoString:&str];
        
        if (flag == YES) {
            if (([str isEqualToString:@"Black"] == YES) || 
                ([str isEqualToString:@"White"] == YES) || 
                ([str isEqualToString:@"wins"] == YES)) {
    //        	NSLog(@"%@",str);
                flag = NO;
            } else {
                if ([str isEqualToString:@"1."] == YES) {
                    fStart = YES;
                } else {
                    len = [str length];
                    dot = [str substringFromIndex:(len - 1)];
                    if ([dot isEqualToString:@"."] == YES) {
                    } else {        
                        if (fStart == YES) {
                            //NSLog(@"%@", str);
                            [self StepKif:str];
                        }
                    }
                }
            }
        }
    } while (flag == YES);

    [self setName];
}

//  str  num Ԗڂ̕oB
- (NSString *)pickUpStr:(NSString *)str :(int)num {
    NSRange range;
    unsigned int len;
    NSString *error = @"error";

    len = [str length];
    
    if (len < (num+1)) {
        return error;
    }
    
    range.location = num;
    range.length = 1;
    return [str substringWithRange:range];
}

// WϊB
- (int)convertNumber:(NSString *)str {
    int num = -1;

    if ([str isEqualToString:@"a"] == YES) {
        num = 9;
    } else if ([str isEqualToString:@"b"] == YES) {
        num = 8;
    } else if ([str isEqualToString:@"c"] == YES) {
        num = 7;
    } else if ([str isEqualToString:@"d"] == YES) {
        num = 6;
    } else if ([str isEqualToString:@"e"] == YES) {
        num = 5;
    } else if ([str isEqualToString:@"f"] == YES) {
        num = 4;
    } else if ([str isEqualToString:@"g"] == YES) {
        num = 3;
    } else if ([str isEqualToString:@"h"] == YES) {
        num = 2;
    } else if ([str isEqualToString:@"i"] == YES) {
        num = 1;
    } else if ([str isEqualToString:@"9"] == YES) {
        num = 1;
    } else if ([str isEqualToString:@"8"] == YES) {
        num = 2;
    } else if ([str isEqualToString:@"7"] == YES) {
        num = 3;
    } else if ([str isEqualToString:@"6"] == YES) {
        num = 4;
    } else if ([str isEqualToString:@"5"] == YES) {
        num = 5;
    } else if ([str isEqualToString:@"4"] == YES) {
        num = 6;
    } else if ([str isEqualToString:@"3"] == YES) {
        num = 7;
    } else if ([str isEqualToString:@"2"] == YES) {
        num = 8;
    } else if ([str isEqualToString:@"1"] == YES) {
        num = 9;
    }
    return num;
}

// ̏𓾂B
- (void)motigoma:(NSString *)str :(BoardCell *)cell {
    if ([str isEqualToString:@"L"] == YES) {
        if (((_senteKomaKind > 0) && ((_indexKif % 2) == 0)) ||
            ((_senteKomaKind < 0) && ((_indexKif % 2) == 1)))
        {
            [cell setBoardCellKomaKind:SENTE_KYOUSYA];
            [cell setBoardCellX:13];
            [cell setBoardCellY:2];
            [cell setBoardCellCount:1];          
        } else {
            [cell setBoardCellKomaKind:GOTE_KYOUSYA];
            [cell setBoardCellX:13];
            [cell setBoardCellY:8];
            [cell setBoardCellCount:1];          
        }
    } else if ([str isEqualToString:@"N"] == YES) {
        if (((_senteKomaKind > 0) && ((_indexKif % 2) == 0)) ||
            ((_senteKomaKind < 0) && ((_indexKif % 2) == 1)))
        {
            [cell setBoardCellKomaKind:SENTE_KEIMA];
            [cell setBoardCellX:11];
            [cell setBoardCellY:2];
            [cell setBoardCellCount:1];          
        } else { 
            [cell setBoardCellKomaKind:GOTE_KEIMA];
            [cell setBoardCellX:11];
            [cell setBoardCellY:8];
            [cell setBoardCellCount:1];          
        }
    } else if ([str isEqualToString:@"S"] == YES) {
        if (((_senteKomaKind > 0) && ((_indexKif % 2) == 0)) ||
            ((_senteKomaKind < 0) && ((_indexKif % 2) == 1)))
        { 
            [cell setBoardCellKomaKind:SENTE_GIN];
            [cell setBoardCellX:13];
            [cell setBoardCellY:3];
            [cell setBoardCellCount:1];          
        } else {
            [cell setBoardCellKomaKind:GOTE_GIN];
            [cell setBoardCellX:13];
            [cell setBoardCellY:7];
            [cell setBoardCellCount:1];          
        }

    } else if ([str isEqualToString:@"G"] == YES) {
        if (((_senteKomaKind > 0) && ((_indexKif % 2) == 0)) ||
            ((_senteKomaKind < 0) && ((_indexKif % 2) == 1))) 
        {
            [cell setBoardCellKomaKind:SENTE_KIN];
            [cell setBoardCellX:11];
            [cell setBoardCellY:3];
            [cell setBoardCellCount:1];          
        } else { 
            [cell setBoardCellKomaKind:GOTE_KIN];
            [cell setBoardCellX:11];
            [cell setBoardCellY:7];
            [cell setBoardCellCount:1];          
        }

    } else if ([str isEqualToString:@"R"] == YES) {
        if (((_senteKomaKind > 0) && ((_indexKif % 2) == 0)) ||
            ((_senteKomaKind < 0) && ((_indexKif % 2) == 1)))
        {
            [cell setBoardCellKomaKind:SENTE_HISYA];
            [cell setBoardCellX:11];
            [cell setBoardCellY:4];
            [cell setBoardCellCount:1];          
        } else {
            [cell setBoardCellKomaKind:GOTE_HISYA];
            [cell setBoardCellX:11];
            [cell setBoardCellY:6];
            [cell setBoardCellCount:1];          
        }

    } else if ([str isEqualToString:@"B"] == YES) {
        if (((_senteKomaKind > 0) && ((_indexKif % 2) == 0)) ||
            ((_senteKomaKind < 0) && ((_indexKif % 2) == 1)))
        { 
            [cell setBoardCellKomaKind:SENTE_KAKU];
            [cell setBoardCellX:13];
            [cell setBoardCellY:4];
            [cell setBoardCellCount:1];          
        } else {
            [cell setBoardCellKomaKind:GOTE_KAKU];
            [cell setBoardCellX:13];
            [cell setBoardCellY:6];
            [cell setBoardCellCount:1];          
        }

    } else if ([str isEqualToString:@"P"] == YES) {
        if (((_senteKomaKind > 0) && ((_indexKif % 2) == 0)) ||
            ((_senteKomaKind < 0) && ((_indexKif % 2) == 1)))
        {
            [cell setBoardCellKomaKind:SENTE_FU];
            [cell setBoardCellX:11];
            [cell setBoardCellY:1];
            [cell setBoardCellCount:1];          
        } else {
            [cell setBoardCellKomaKind:GOTE_FU];
            [cell setBoardCellX:11];
            [cell setBoardCellY:9];
            [cell setBoardCellCount:1];          
        }

    }
}

// ɓo^B
- (void)StepKif:(NSString *)kifStr {
    NSString *sChar;
    int x,y;
    int x1,y1;
    int x2,y2;
    
    sChar = [self pickUpStr:kifStr :1];
    // łꍇB
    if ([sChar isEqualToString:@"*"] == YES) {

        sChar = [self pickUpStr:kifStr :0];
        [self motigoma:sChar :_selectSource];

        x = [_selectSource boardCellX];
        y = [_selectSource boardCellY];    
        if ([_board[x][y] boardCellCount] == 1) {
            [_board[x][y] eraseBoardCell];
        } else {
            [_board[x][y] setBoardCellCount:[_board[x][y] boardCellCount] - 1];
        }

        sChar = [self pickUpStr:kifStr :2];
        x1 = [self convertNumber:sChar];
        sChar = [self pickUpStr:kifStr :3];
        y1 = [self convertNumber:sChar];

        [_selectDestination boardCellCopy:_selectSource];
        [_selectDestination setBoardCellX:x1];
        [_selectDestination setBoardCellY:y1];

        [_board[x1][y1] boardCellCopy:_selectDestination];

        [_placeSource setBoardCellX:x1];
        [_placeSource setBoardCellY:y1];

        [_placeDestination setBoardCellX:x1];
        [_placeDestination setBoardCellY:y1];
        
    // ړꍇB
    } else {
        sChar = [self pickUpStr:kifStr :0];
        x = [self convertNumber:sChar];
        sChar = [self pickUpStr:kifStr :1];
        y = [self convertNumber:sChar];
        sChar = [self pickUpStr:kifStr :2];
        x1 = [self convertNumber:sChar];
        sChar = [self pickUpStr:kifStr :3];
        y1 = [self convertNumber:sChar];

        [_selectSource boardCellCopy:_board[x][y]];
        [_board[x][y] eraseBoardCell];
        [_placeSource boardCellCopy:_board[x1][y1]];
        [_board[x1][y1] eraseBoardCell];
        [_placeDestination boardCellCopy:_placeSource];
        [_placeDestination reversePromote];

        if ([_placeDestination boardCellKomaKind] != KOMA_NASHI) {
            x2 = [_placeDestination boardCellX];
            y2 = [_placeDestination boardCellY];    
            [_board[x2][y2] boardCellCopyExceptCount:_placeDestination];
            [_board[x2][y2] setBoardCellCount:[_board[x2][y2] boardCellCount]
                     + 1];
        }
                
        [_selectDestination boardCellCopy:_selectSource];
        [_selectDestination setBoardCellX:x1];
        [_selectDestination setBoardCellY:y1];

        // ꍇB
        sChar = [self pickUpStr:kifStr :4];
        if ([sChar isEqualToString:@"+"] == YES) {
            [_selectDestination promote];
        }

        [_board[x1][y1] boardCellCopy:_selectDestination];

    }
    
    if (_indexKif == 0) {
        _senteKomaKind = [_selectSource boardCellKomaKind];
    }
    
    // o^B
    [_ykifController addKifController:_selectSource :_selectDestination :_placeSource :_placeDestination];

//    [self printKif];
    [self eraseSelectPlace];
    _indexKif++;
}

// B
- (void)eraseSelectPlace {
    [_selectSource eraseBoardCell];
    [_selectDestination eraseBoardCell];
    [_placeSource eraseBoardCell];
    [_placeDestination eraseBoardCell];
}

//@\B
- (void)printKif {
    NSLog(@"[--][%d]------",_indexKif);
    [_selectSource printBoardCell];
    [_selectDestination printBoardCell];
    [_placeSource printBoardCell];
    [_placeDestination printBoardCell];
}

// ̉
- (void)dealloc {
   int i, j;
    
    for (i=0; i<MAX_WIDTH; i++) {
        for (j=0; j<MAX_HEIGHT; j++) {
            [_board[i][j] release];
        }
    }

    [_selectSource release];
    [_selectDestination release];
    [_placeSource release];
    [_placeDestination release];
 
    [super dealloc];
}

@end
